<?php
	/***************************************************************
	*  Copyright notice
	*
	*  (c) 2008 Peter Klein <peter@umloud.dk>
	*  All rights reserved
	*
	*  This script is part of the TYPO3 project. The TYPO3 project is
	*  free software; you can redistribute it and/or modify
	*  it under the terms of the GNU General Public License as published by
	*  the Free Software Foundation; either version 2 of the License, or
	*  (at your option) any later version.
	*
	*  The GNU General Public License can be found at
	*  http://www.gnu.org/copyleft/gpl.html.
	*
	*  This script is distributed in the hope that it will be useful,
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	*  GNU General Public License for more details.
	*
	*  This copyright notice MUST APPEAR in all copies of the script!
	***************************************************************/

/**
 * Class for updating the db
 *
 * @author	 Peter Klein <peter@umloud.dk>
 */
class ext_update  {

	/**
	 * Main function, returning the HTML content of the module
	 *
	 * @return	string		HTML
	 */
	function main()	{

		$rootPages = $this->getRecords('pages','pid=0');
		$rootPage = intval(t3lib_div::_GP('branch'));
		$mode = intval(t3lib_div::_GP('mode'));
		$content = '';
		
		$content .= '<form name="pmkautokeywords_form" action="'.htmlspecialchars(t3lib_div::linkThisScript()).'" method="post">';
		$linkScript = t3lib_div::slashJS(t3lib_div::linkThisScript());
		$content .= '<br /><br />';
		$content .= 'Select branch of the pagetree to aplly changes to: ';
		$content .= $this->makeSelect($rootPages,$rootPage,'branch');
		$content .= '<br /><br />';
		$content .= 'Set the Page field "Use autokeywords: to: ';
		$content .= $this->makeSelect(array(
			array(
				'title' =>'Checked',
				 'uid' => 1
			),
			array(
				'title' => 'Unchecked',
				'uid' => 2
			)
		),$mode,'mode');
		$content .= '<br /><br />';
		$content .= '<input type="submit" name="update" value="Update"  onclick="this.form.action=\''.$linkScript.'\';submit();" />';
		$content .= '</form>';

		if (t3lib_div::_GP('update') && $rootPage>0 && $mode>0) {
			$this->mode = $mode==1 ? 1 : 0;
			$content .= '<h3>The folowing pages has been updated:</h3>';
			$content .= '<p>'.$this->processPage($rootPage).'</p>';
		}
		
		return $content;
	}

	/**
	 * access is always allowed
	 *
	 * @return	boolean		Always returns true
	 */
	function access() {
		return true;
	}

	function getRecords($table, $where) {
		$out = array();
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', $table, $where);
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			$out[] = $row;
		}
		return $out;
	}
	
	function makeSelect($data,$selected,$name) {
		$out = '<option value="0">Please select...</option>';
		foreach ($data as $page) {
			$out.= '<option value="'.$page['uid'].'"'.($page['uid']==$selected ? ' selected="selected"' : '').'>'.$page['title'].'</option>';
		}
		return '<select name="'.$name.'">'.$out.'</select>';
	}
	
	function processPage($uid,$out='',$indent='') {
		$GLOBALS['TYPO3_DB']->exec_UPDATEquery(
			'pages',
			'uid='.$uid,
			array(
				'tx_pmkautokeywords_useautokeywords' => $this->mode
			)
		);
		// Process subpages
		$pages = $this->getRecords('pages', 'deleted=0 AND hidden=0 AND doktype=1 AND pid='.$uid);
		$indent.='&nbsp;&nbsp;&nbsp;';
		foreach ($pages as $page) {
			$out.=$indent.$page['title'].'<br />';
			$this->processPage($page['uid'],&$out,$indent);
			
			// Check if there exists any pages_language_overlay records on this page
			if ($overlayIds = $this->getPageLanguageOverlayUids($page['uid'])) {
				foreach ($overlayIds as $overlayId) {
					$GLOBALS['TYPO3_DB']->exec_UPDATEquery(
						'pages_language_overlay',
						'uid='.$overlayId,
						array(
							'tx_pmkautokeywords_useautokeywords' => $this->mode
						)
					);
				}
			}
		}
		return $out;
	}
	
	/**
	 * Returns array of pages_language_overlay uids
	 *
	 * @param	integer		$pageId: uid of page record
	 * @return	array		array of pages_language_overlay uids linked to page record
	 */
	function getPageLanguageOverlayUids($pageId) {
		$uidArray = array();
		$where = 'pid='.$pageId.' AND deleted=0 AND hidden=0';
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid', 'pages_language_overlay', $where);
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			$uidArray[] = $row['uid'];
		}
		return $uidArray;
	}
	
}

// Include extension?
if (defined('TYPO3_MODE') && $GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/pmkautokeywords/class.ext_update.php'])	{
	include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/pmkautokeywords/class.ext_update.php']);
}


?>
